=== debian/control ===
Source: ros-melodic-opw-kinematics
Section: misc
Priority: optional
Maintainer: Jon Meyer <jmeyer@swri.org>
Build-Depends: debhelper (>= 9.0.0), cmake, libeigen3-dev, libgtest-dev, ros-melodic-ros-industrial-cmake-boilerplate
Homepage: 
Standards-Version: 3.9.2

Package: ros-melodic-opw-kinematics
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libeigen3-dev
Description: A simple, analytical inverse kinematic library for industrial robots with parallel bases and spherical wrists.
 Based on the paper &quot;An Analytical Solution of the Inverse Kinematics Problem of Industrial Serial Manipulators with an Ortho-parallel Basis and a Spherical Wrist&quot; by Mathias Brandstötter, Arthur Angerer, and Michael Hofbaur.
